---
product: "AG Grid"
title: "Theme Parts"
description: "Parts contain the CSS styles for a single feature like icons or text inputs."
framework: javascript
version: "36.2.0"
related:
    - title: "Overview"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/theming/"
    - title: "Built-in Themes"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/themes/"
    - title: "Theme Parameters"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/theming-parameters/"
    - title: "Colors & Dark Mode"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/theming-colors/"
    - title: "Fonts"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/theming-fonts/"
    - title: "Borders"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/theming-borders/"
    - title: "Compactness & Row Height"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/theming-compactness/"
    - title: "Selections"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/theming-selections/"
    - title: "Headers"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/theming-headers/"
    - title: "Icons"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/custom-icons/"
    - title: "Master Detail"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/theming-master-detail/"
    - title: "Tool Panels"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/theming-tool-panels/"
    - title: "Inputs & Widgets"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/theming-widgets/"
    - title: "Menus & Popups"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/theming-popups/"
    - title: "Extending with CSS"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/theming-css/"
    - title: "Theme Builder"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/theming-theme-builder/"
    - title: "Distributing Shared Themes"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/theming-distribution/"
    - title: "Migration from v32"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/theming-migration/"
    - title: "Legacy Themes"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/theming-v32/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Theme Parts

Parts contain the CSS styles for a single feature like icons or text inputs.

Using parts you can, for example, select a text input style that matches you application, or disable our provided text input styles so that you can write your own.

## Configuring Theme Parts

To add a part to a theme, call the `theme.withPart(...)` method which returns a new theme using that part. A theme can only have one part for a given feature, so for example because all colour scheme parts have `feature: "colorScheme"`, adding a new colour scheme to a theme will remove any existing part.

```js
import { themeQuartz, colorSchemeDark, iconSetMaterial } from 'ag-grid-community';

// withPart() returns a new theme and calls can be chained
const myTheme = themeQuartz
    .withPart(iconSetMaterial)
    .withPart(colorSchemeDark);
```

This example demonstrates mixing and matching any built-in theme, icon set, and colour scheme:

#### Configuring Theme Parts

```ts
import {
  ColDef,
  GridOptions,
  ModuleRegistry,
  Part,
  Theme,
  colorSchemeDark,
  colorSchemeDarkBlue,
  colorSchemeDarkWarm,
  colorSchemeLight,
  colorSchemeLightCold,
  colorSchemeLightWarm,
  createGrid,
  enableDevValidations,
  iconSetAlpine,
  iconSetMaterial,
  iconSetQuartzBold,
  iconSetQuartzLight,
  iconSetQuartzRegular,
  themeAlpine,
  themeBalham,
  themeMaterial,
  themeQuartz,
} from "ag-grid-community";
import { AllEnterpriseModule } from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([AllEnterpriseModule]);

const baseThemes: Record<string, Theme> = {
  quartz: themeQuartz,
  balham: themeBalham,
  alpine: themeAlpine,
  material: themeMaterial,
};
let baseTheme = themeQuartz;

const colorSchemes: Record<string, Part> = {
  light: colorSchemeLight,
  lightCold: colorSchemeLightCold,
  lightWarm: colorSchemeLightWarm,
  dark: colorSchemeDark,
  darkWarm: colorSchemeDarkWarm,
  darkBlue: colorSchemeDarkBlue,
};
let colorScheme: Part | null = null;

const iconSets: Record<string, Part> = {
  quartzLight: iconSetQuartzLight,
  quartzRegular: iconSetQuartzRegular,
  quartzBold: iconSetQuartzBold,
  alpine: iconSetAlpine,
  material: iconSetMaterial,
};
let iconSet: Part | null = null;

const columnDefs: ColDef[] = [
  { field: "make" },
  { field: "model" },
  { field: "price" },
];

const rowData: any[] = (() => {
  const rowData: any[] = [];
  for (let i = 0; i < 10; i++) {
    rowData.push({ make: "Toyota", model: "Celica", price: 35000 + i * 1000 });
    rowData.push({ make: "Ford", model: "Mondeo", price: 32000 + i * 1000 });
    rowData.push({
      make: "Porsche",
      model: "Boxster",
      price: 72000 + i * 1000,
    });
  }
  return rowData;
})();

const defaultColDef = {
  editable: true,
  flex: 1,
  minWidth: 100,
  filter: true,
  enableRowGroup: true,
  enablePivot: true,
  enableValue: true,
};

const gridOptions: GridOptions<IOlympicData> = {
  theme: buildTheme(),
  columnDefs,
  rowData,
  defaultColDef,
  sideBar: true,
};

const gridApi = createGrid(
  document.querySelector<HTMLElement>("#myGrid")!,
  gridOptions,
);

function setBaseTheme(id: string) {
  baseTheme = baseThemes[id];
  gridApi.setGridOption("theme", buildTheme());
}

function setIconSet(id: string) {
  iconSet = iconSets[id] || null;
  gridApi.setGridOption("theme", buildTheme());
}

function setColorScheme(id: string) {
  colorScheme = colorSchemes[id] || null;
  gridApi.setGridOption("theme", buildTheme());
}

function buildTheme() {
  let theme = baseTheme;
  if (iconSet) {
    theme = theme.withPart(iconSet);
  }
  if (colorScheme) {
    theme = theme.withPart(colorScheme);
  }
  return theme;
}

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).setBaseTheme = setBaseTheme;
  (<any>window).setIconSet = setIconSet;
  (<any>window).setColorScheme = setColorScheme;
}
```

[Live example: Configuring Theme Parts](https://www.ag-grid.com/archive/36.2.0/examples/theming-parts/configuring-theme-parts/typescript/)

## Parts Reference

The following parts are available:

- `colorScheme` feature:
  - `colorSchemeVariable` - the default colour scheme for all our [built-in themes](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/themes/#built-in-themes). By default it appears light, but can be adjusted using [theme modes](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/theming-colors/#theme-modes).
  - `colorSchemeLight` - neutral light scheme
  - `colorSchemeLightCold` - light scheme with subtle cold tint
  - `colorSchemeLightWarm` - light scheme with subtle warm tint
  - `colorSchemeDark` - neutral dark scheme
  - `colorSchemeDarkBlue` - our preferred dark scheme used on this website
  - `colorSchemeDarkWarm` - dark scheme with subtle warm tint
- `iconSet` feature:
  - `iconSetQuartz` - our default icon set
    - `iconSetQuartz({strokeWidth: number})` you can call iconSetQuartz as a function to provide a custom stroke width in pixels (the default is 1.5)
    - `iconSetQuartzLight` and `iconSetQuartzBold` preset lighter and bolder versions of the Quartz icons with 1px and 2px stroke widths respectively.
  - `iconSetMaterial` - the Material Design icon set
  - `iconSetAlpine` - the icon set used by the Alpine theme
  - `iconSetBalham` - the icon set used by the Balham theme
- `buttonStyle` feature:
  - `buttonStyleBase` - unstyled buttons with many parameters to configure their appearance
  - `buttonStyleQuartz` - buttons styled as per the Quartz theme
  - `buttonStyleAlpine` - buttons styled as per the Alpine theme
  - `buttonStyleBalham` - buttons styled as per the Balham theme
- `columnDropStyle` feature - controls the styling of column drop zone in the [columns tool panel](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/tool-panel-columns/):
  - `columnDropStylePlain` - undecorated drop zone as used by Balham and Material themes
  - `columnDropStyleBordered` - drop zone with a dashed border around it as used by the Quartz and Alpine themes.
- `checkboxStyle` feature:
  - `checkboxStyleDefault` - checkbox style used by our themes. There is only one style provided which is configurable through parameters. It being a part allows you to replace it with your own checkbox styles if desired.
- `inputStyle` feature:
  - `inputStyleBase` - unstyled inputs with many parameters to configure their appearance
  - `inputStyleBordered` - inputs with a border around them
  - `inputStyleUnderlined` - inputs with a line underneath them as used in Material Design
- `tabStyle` feature:
  - `tabStyleBase` - unstyled tabs with many parameters to configure their appearance
  - `tabStyleQuartz` - tabs styled as per the Quartz theme
  - `tabStyleMaterial` - tabs styled as per the Material theme
  - `tabStyleAlpine` - tabs styled as per the Alpine theme
  - `tabStyleRolodex` - tabs designed to imitate paper cards, as used by the Balham theme
- `styleMaterial` feature (used by the Material theme):
  - `styleMaterial` - Adds the `primaryColor` parameter defined by [Material Design v2](https://m2.material.io/) and uses this colour instead of the `accentColor` for most coloured elements. `accentColor` is still used for checked checkboxes and to highlight active filters. This part also applies some adjustments to appearance of elements to match the Material Design specification, e.g. making all button text uppercase.

## Removing a Part

To remove a part from a theme, call `theme.withoutPart(featureName)`, which returns a new theme without the specified part:

```js
const myCustomTheme = themeQuartz.withoutPart('checkboxStyle');
```

After removing the built-in part, this example uses CSS in a separate style sheet to style the checkboxes:

#### Configuring Theme Parts

```ts
import "./style.css";
import {
  ColDef,
  GridOptions,
  ModuleRegistry,
  createGrid,
  enableDevValidations,
  themeQuartz,
} from "ag-grid-community";
import { AllEnterpriseModule } from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

import "./style.css";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([AllEnterpriseModule]);

const myCustomTheme = themeQuartz.withoutPart("checkboxStyle");

const columnDefs: ColDef[] = [
  { field: "make" },
  { field: "model" },
  { field: "price" },
];

const rowData: any[] = (() => {
  const rowData: any[] = [];
  for (let i = 0; i < 10; i++) {
    rowData.push({ make: "Toyota", model: "Celica", price: 35000 + i * 1000 });
    rowData.push({ make: "Ford", model: "Mondeo", price: 32000 + i * 1000 });
    rowData.push({
      make: "Porsche",
      model: "Boxster",
      price: 72000 + i * 1000,
    });
  }
  return rowData;
})();

const gridOptions: GridOptions<IOlympicData> = {
  theme: myCustomTheme,
  columnDefs,
  rowData,
  defaultColDef: {
    editable: true,
    flex: 1,
    minWidth: 100,
    filter: true,
  },
  initialState: {
    rowSelection: ["1", "2", "3"],
  },
  rowSelection: { mode: "multiRow", checkboxes: true },
};

createGrid(document.querySelector<HTMLElement>("#myGrid")!, gridOptions);
```

[Live example: Configuring Theme Parts](https://www.ag-grid.com/archive/36.2.0/examples/theming-parts/removing-parts/typescript/)

The above example uses `theme.withoutPart("checkboxStyle")` to disable the default checkbox styles and adds its own checkbox styles in the application style sheet. This is the simplest way of changing the appearance of the grid when you are working on a single application.

## Creating Your Own Parts

You can create your own theme parts to use in your application. This is useful for organisations with multiple apps that share common styles or a design system, see [Distributing Shared Themes & Parts](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/theming-distribution/#creating-your-own-parts).


---
product: "AG Grid"
title: "Theme Parts"
description: "Parts contain the CSS styles for a single feature like icons or text inputs."
framework: react
version: "36.2.0"
related:
    - title: "Overview"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/theming/"
    - title: "Built-in Themes"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/themes/"
    - title: "Theme Parameters"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/theming-parameters/"
    - title: "Colors & Dark Mode"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/theming-colors/"
    - title: "Fonts"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/theming-fonts/"
    - title: "Borders"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/theming-borders/"
    - title: "Compactness & Row Height"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/theming-compactness/"
    - title: "Selections"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/theming-selections/"
    - title: "Headers"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/theming-headers/"
    - title: "Icons"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/custom-icons/"
    - title: "Master Detail"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/theming-master-detail/"
    - title: "Tool Panels"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/theming-tool-panels/"
    - title: "Inputs & Widgets"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/theming-widgets/"
    - title: "Menus & Popups"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/theming-popups/"
    - title: "Extending with CSS"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/theming-css/"
    - title: "Theme Builder"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/theming-theme-builder/"
    - title: "Distributing Shared Themes"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/theming-distribution/"
    - title: "Migration from v32"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/theming-migration/"
    - title: "Legacy Themes"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/theming-v32/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Theme Parts

Parts contain the CSS styles for a single feature like icons or text inputs.

Using parts you can, for example, select a text input style that matches you application, or disable our provided text input styles so that you can write your own.

## Configuring Theme Parts

To add a part to a theme, call the `theme.withPart(...)` method which returns a new theme using that part. A theme can only have one part for a given feature, so for example because all colour scheme parts have `feature: "colorScheme"`, adding a new colour scheme to a theme will remove any existing part.

```js
import { themeQuartz, colorSchemeDark, iconSetMaterial } from 'ag-grid-community';

// withPart() returns a new theme and calls can be chained
const myTheme = themeQuartz
    .withPart(iconSetMaterial)
    .withPart(colorSchemeDark);
```

This example demonstrates mixing and matching any built-in theme, icon set, and colour scheme:

#### Configuring Theme Parts

```tsx
'use client';
import React, { StrictMode, useMemo, useState } from "react";
import { createRoot } from "react-dom/client";

import {
  colorSchemeDark,
  colorSchemeDarkBlue,
  colorSchemeDarkWarm,
  colorSchemeLight,
  colorSchemeLightCold,
  colorSchemeLightWarm,
  colorSchemeVariable,
  iconSetAlpine,
  iconSetMaterial,
  iconSetQuartzBold,
  iconSetQuartzLight,
  iconSetQuartzRegular,
  themeAlpine,
  themeBalham,
  themeMaterial,
  themeQuartz,
} from "ag-grid-community";
import { AllEnterpriseModule } from "ag-grid-enterprise";
import { AgGridProvider, AgGridReact } from "ag-grid-react";

const baseThemes = [
  { id: "themeQuartz", value: themeQuartz },
  { id: "themeBalham", value: themeBalham },
  { id: "themeAlpine", value: themeAlpine },
  { id: "themeMaterial", value: themeMaterial },
];

const colorSchemes = [
  { id: "(unchanged)", value: null },
  { id: "colorSchemeLight", value: colorSchemeLight },
  { id: "colorSchemeLightCold", value: colorSchemeLightCold },
  { id: "colorSchemeLightWarm", value: colorSchemeLightWarm },
  { id: "colorSchemeDark", value: colorSchemeDark },
  { id: "colorSchemeDarkWarm", value: colorSchemeDarkWarm },
  { id: "colorSchemeDarkBlue", value: colorSchemeDarkBlue },
  { id: "colorSchemeVariable", value: colorSchemeVariable },
];

const iconSets = [
  { id: "(unchanged)", value: null },
  { id: "iconSetQuartzLight", value: iconSetQuartzLight },
  { id: "iconSetQuartzRegular", value: iconSetQuartzRegular },
  { id: "iconSetQuartzBold", value: iconSetQuartzBold },
  { id: "iconSetAlpine", value: iconSetAlpine },
  { id: "iconSetMaterial", value: iconSetMaterial },
];

const GridExample = () => {
  const [baseTheme, setBaseTheme] = useState(baseThemes[0]);
  const [colorScheme, setColorScheme] = useState(colorSchemes[0]);
  const [iconSet, setIconSet] = useState(iconSets[0]);

  const theme = useMemo(() => {
    let theme = baseTheme.value;
    if (colorScheme.value) {
      theme = theme.withPart(colorScheme.value);
    }
    if (iconSet.value) {
      theme = theme.withPart(iconSet.value);
    }
    return theme;
  }, [baseTheme, colorScheme, iconSet]);

  return (
    <AgGridProvider modules={[AllEnterpriseModule]}>
      <div style={{ height: "100%", display: "flex", flexDirection: "column" }}>
        <p style={{ flex: 0 }}>
          Theme:{" "}
          <PartSelector
            options={baseThemes}
            value={baseTheme}
            setValue={setBaseTheme}
          />
          Icons:{" "}
          <PartSelector
            options={iconSets}
            value={iconSet}
            setValue={setIconSet}
          />
          Color scheme:{" "}
          <PartSelector
            options={colorSchemes}
            value={colorScheme}
            setValue={setColorScheme}
          />
        </p>
        <div style={{ flex: 1 }}>
          <AgGridReact
            theme={theme}
            columnDefs={columnDefs}
            rowData={rowData}
            defaultColDef={defaultColDef}
            sideBar
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

type PartSelectorProps<T extends { id: string } | null> = {
  options: T[];
  value: T;
  setValue: (value: T) => void;
};

const PartSelector = <T extends { id: string }>({
  options,
  value,
  setValue,
}: PartSelectorProps<T>) => (
  <select
    onChange={(e) =>
      setValue(options.find((t) => t?.id === e.currentTarget.value)! || null)
    }
    style={{ marginRight: 16 }}
    value={value?.id}
  >
    {options.map((option, i) => (
      <option key={i}>{option.id}</option>
    ))}
  </select>
);

const rowData: any[] = (() => {
  const rowData: any[] = [];
  for (let i = 0; i < 10; i++) {
    rowData.push({ make: "Toyota", model: "Celica", price: 35000 + i * 1000 });
    rowData.push({ make: "Ford", model: "Mondeo", price: 32000 + i * 1000 });
    rowData.push({
      make: "Porsche",
      model: "Boxster",
      price: 72000 + i * 1000,
    });
  }
  return rowData;
})();

const columnDefs = [{ field: "make" }, { field: "model" }, { field: "price" }];

const defaultColDef = {
  editable: true,
  flex: 1,
  minWidth: 100,
  filter: true,
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Configuring Theme Parts](https://www.ag-grid.com/archive/36.2.0/examples/theming-parts/configuring-theme-parts/reactFunctionalTs/)

## Parts Reference

The following parts are available:

- `colorScheme` feature:
  - `colorSchemeVariable` - the default colour scheme for all our [built-in themes](https://www.ag-grid.com/archive/36.2.0/react-data-grid/themes/#built-in-themes). By default it appears light, but can be adjusted using [theme modes](https://www.ag-grid.com/archive/36.2.0/react-data-grid/theming-colors/#theme-modes).
  - `colorSchemeLight` - neutral light scheme
  - `colorSchemeLightCold` - light scheme with subtle cold tint
  - `colorSchemeLightWarm` - light scheme with subtle warm tint
  - `colorSchemeDark` - neutral dark scheme
  - `colorSchemeDarkBlue` - our preferred dark scheme used on this website
  - `colorSchemeDarkWarm` - dark scheme with subtle warm tint
- `iconSet` feature:
  - `iconSetQuartz` - our default icon set
    - `iconSetQuartz({strokeWidth: number})` you can call iconSetQuartz as a function to provide a custom stroke width in pixels (the default is 1.5)
    - `iconSetQuartzLight` and `iconSetQuartzBold` preset lighter and bolder versions of the Quartz icons with 1px and 2px stroke widths respectively.
  - `iconSetMaterial` - the Material Design icon set
  - `iconSetAlpine` - the icon set used by the Alpine theme
  - `iconSetBalham` - the icon set used by the Balham theme
- `buttonStyle` feature:
  - `buttonStyleBase` - unstyled buttons with many parameters to configure their appearance
  - `buttonStyleQuartz` - buttons styled as per the Quartz theme
  - `buttonStyleAlpine` - buttons styled as per the Alpine theme
  - `buttonStyleBalham` - buttons styled as per the Balham theme
- `columnDropStyle` feature - controls the styling of column drop zone in the [columns tool panel](https://www.ag-grid.com/archive/36.2.0/react-data-grid/tool-panel-columns/):
  - `columnDropStylePlain` - undecorated drop zone as used by Balham and Material themes
  - `columnDropStyleBordered` - drop zone with a dashed border around it as used by the Quartz and Alpine themes.
- `checkboxStyle` feature:
  - `checkboxStyleDefault` - checkbox style used by our themes. There is only one style provided which is configurable through parameters. It being a part allows you to replace it with your own checkbox styles if desired.
- `inputStyle` feature:
  - `inputStyleBase` - unstyled inputs with many parameters to configure their appearance
  - `inputStyleBordered` - inputs with a border around them
  - `inputStyleUnderlined` - inputs with a line underneath them as used in Material Design
- `tabStyle` feature:
  - `tabStyleBase` - unstyled tabs with many parameters to configure their appearance
  - `tabStyleQuartz` - tabs styled as per the Quartz theme
  - `tabStyleMaterial` - tabs styled as per the Material theme
  - `tabStyleAlpine` - tabs styled as per the Alpine theme
  - `tabStyleRolodex` - tabs designed to imitate paper cards, as used by the Balham theme
- `styleMaterial` feature (used by the Material theme):
  - `styleMaterial` - Adds the `primaryColor` parameter defined by [Material Design v2](https://m2.material.io/) and uses this colour instead of the `accentColor` for most coloured elements. `accentColor` is still used for checked checkboxes and to highlight active filters. This part also applies some adjustments to appearance of elements to match the Material Design specification, e.g. making all button text uppercase.

## Removing a Part

To remove a part from a theme, call `theme.withoutPart(featureName)`, which returns a new theme without the specified part:

```js
const myCustomTheme = themeQuartz.withoutPart('checkboxStyle');
```

After removing the built-in part, this example uses CSS in a separate style sheet to style the checkboxes:

#### Configuring Theme Parts

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./style.css";
import "./style.css";
import {
  ColDef,
  ColGroupDef,
  GridOptions,
  GridState,
  ModuleRegistry,
  RowSelectionOptions,
  Theme,
  enableDevValidations,
  themeQuartz,
} from "ag-grid-community";
import { AllEnterpriseModule } from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [AllEnterpriseModule];

const myCustomTheme = themeQuartz.withoutPart("checkboxStyle");

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<IOlympicData[]>(
    (() => {
      const rowData: any[] = [];
      for (let i = 0; i < 10; i++) {
        rowData.push({
          make: "Toyota",
          model: "Celica",
          price: 35000 + i * 1000,
        });
        rowData.push({
          make: "Ford",
          model: "Mondeo",
          price: 32000 + i * 1000,
        });
        rowData.push({
          make: "Porsche",
          model: "Boxster",
          price: 72000 + i * 1000,
        });
      }
      return rowData;
    })(),
  );
  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "make" },
    { field: "model" },
    { field: "price" },
  ]);
  const theme = useMemo<Theme | "legacy">(() => {
    return myCustomTheme;
  }, []);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      editable: true,
      flex: 1,
      minWidth: 100,
      filter: true,
    };
  }, []);
  const initialState = useMemo<GridState>(() => {
    return {
      rowSelection: ["1", "2", "3"],
    };
  }, []);
  const rowSelection = useMemo<
    RowSelectionOptions | "single" | "multiple"
  >(() => {
    return { mode: "multiRow", checkboxes: true };
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact<IOlympicData>
            rowData={rowData}
            columnDefs={columnDefs}
            theme={theme}
            defaultColDef={defaultColDef}
            initialState={initialState}
            rowSelection={rowSelection}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Configuring Theme Parts](https://www.ag-grid.com/archive/36.2.0/examples/theming-parts/removing-parts/reactFunctionalTs/)

The above example uses `theme.withoutPart("checkboxStyle")` to disable the default checkbox styles and adds its own checkbox styles in the application style sheet. This is the simplest way of changing the appearance of the grid when you are working on a single application.

## Creating Your Own Parts

You can create your own theme parts to use in your application. This is useful for organisations with multiple apps that share common styles or a design system, see [Distributing Shared Themes & Parts](https://www.ag-grid.com/archive/36.2.0/react-data-grid/theming-distribution/#creating-your-own-parts).


---
product: "AG Grid"
title: "Theme Parts"
description: "Parts contain the CSS styles for a single feature like icons or text inputs."
framework: angular
version: "36.2.0"
related:
    - title: "Overview"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/theming/"
    - title: "Built-in Themes"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/themes/"
    - title: "Theme Parameters"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/theming-parameters/"
    - title: "Colors & Dark Mode"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/theming-colors/"
    - title: "Fonts"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/theming-fonts/"
    - title: "Borders"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/theming-borders/"
    - title: "Compactness & Row Height"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/theming-compactness/"
    - title: "Selections"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/theming-selections/"
    - title: "Headers"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/theming-headers/"
    - title: "Icons"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/custom-icons/"
    - title: "Master Detail"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/theming-master-detail/"
    - title: "Tool Panels"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/theming-tool-panels/"
    - title: "Inputs & Widgets"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/theming-widgets/"
    - title: "Menus & Popups"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/theming-popups/"
    - title: "Extending with CSS"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/theming-css/"
    - title: "Theme Builder"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/theming-theme-builder/"
    - title: "Distributing Shared Themes"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/theming-distribution/"
    - title: "Migration from v32"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/theming-migration/"
    - title: "Legacy Themes"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/theming-v32/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Theme Parts

Parts contain the CSS styles for a single feature like icons or text inputs.

Using parts you can, for example, select a text input style that matches you application, or disable our provided text input styles so that you can write your own.

## Configuring Theme Parts

To add a part to a theme, call the `theme.withPart(...)` method which returns a new theme using that part. A theme can only have one part for a given feature, so for example because all colour scheme parts have `feature: "colorScheme"`, adding a new colour scheme to a theme will remove any existing part.

```js
import { themeQuartz, colorSchemeDark, iconSetMaterial } from 'ag-grid-community';

// withPart() returns a new theme and calls can be chained
const myTheme = themeQuartz
    .withPart(iconSetMaterial)
    .withPart(colorSchemeDark);
```

This example demonstrates mixing and matching any built-in theme, icon set, and colour scheme:

#### Configuring Theme Parts

```ts
import { CommonModule } from "@angular/common";
import { Component } from "@angular/core";
import { FormsModule } from "@angular/forms";

import { AgGridAngular } from "ag-grid-angular";
import type { ColDef } from "ag-grid-community";
import {
  ModuleRegistry,
  colorSchemeDark,
  colorSchemeDarkBlue,
  colorSchemeDarkWarm,
  colorSchemeLight,
  colorSchemeLightCold,
  colorSchemeLightWarm,
  colorSchemeVariable,
  enableDevValidations,
  iconSetAlpine,
  iconSetMaterial,
  iconSetQuartzBold,
  iconSetQuartzLight,
  iconSetQuartzRegular,
  themeAlpine,
  themeBalham,
  themeMaterial,
  themeQuartz,
} from "ag-grid-community";
import { AllEnterpriseModule } from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([AllEnterpriseModule]);

@Component({
  standalone: true,
  imports: [AgGridAngular, FormsModule, CommonModule],
  selector: "my-app",
  template: `
    <div style="height: 100%; display: flex; flex-direction: column">
      <p style="flex: 0 1 0%">
        Theme:
        <select style="margin-right: 16px" [(ngModel)]="baseTheme">
          <option
            *ngFor="let baseTheme of baseThemes"
            [ngValue]="baseTheme.value"
          >
            {{ baseTheme.id }}
          </option>
        </select>
        Icons:
        <select style="margin-right: 16px" [(ngModel)]="iconSet">
          <option *ngFor="let iconSet of iconSets" [ngValue]="iconSet.value">
            {{ iconSet.id }}
          </option>
        </select>
        Color scheme:
        <select style="margin-right: 16px" [(ngModel)]="colorScheme">
          <option
            *ngFor="let colorScheme of colorSchemes"
            [ngValue]="colorScheme.value"
          >
            {{ colorScheme.id }}
          </option>
        </select>
      </p>
      <div style="flex: 1 1 0%">
        <ag-grid-angular
          style="height: 100%;"
          [columnDefs]="columnDefs"
          [defaultColDef]="defaultColDef"
          [rowData]="rowData"
          [theme]="theme"
          [sideBar]="true"
        />
      </div>
    </div>
  `,
})
export class AppComponent {
  baseThemes = [
    { id: "themeQuartz", value: themeQuartz },
    { id: "themeBalham", value: themeBalham },
    { id: "themeAlpine", value: themeAlpine },
    { id: "themeMaterial", value: themeMaterial },
  ];
  baseTheme = themeQuartz;

  colorSchemes = [
    { id: "(unchanged)", value: null },
    { id: "colorSchemeLight", value: colorSchemeLight },
    { id: "colorSchemeLightCold", value: colorSchemeLightCold },
    { id: "colorSchemeLightWarm", value: colorSchemeLightWarm },
    { id: "colorSchemeDark", value: colorSchemeDark },
    { id: "colorSchemeDarkWarm", value: colorSchemeDarkWarm },
    { id: "colorSchemeDarkBlue", value: colorSchemeDarkBlue },
    { id: "colorSchemeVariable", value: colorSchemeVariable },
  ];
  colorScheme = null;

  iconSets = [
    { id: "(unchanged)", value: null },
    { id: "iconSetQuartzLight", value: iconSetQuartzLight },
    { id: "iconSetQuartzRegular", value: iconSetQuartzRegular },
    { id: "iconSetQuartzBold", value: iconSetQuartzBold },
    { id: "iconSetAlpine", value: iconSetAlpine },
    { id: "iconSetMaterial", value: iconSetMaterial },
  ];
  iconSet = null;

  get theme() {
    let theme = this.baseTheme;
    if (this.iconSet) {
      theme = theme.withPart(this.iconSet);
    }
    if (this.colorScheme) {
      theme = theme.withPart(this.colorScheme);
    }
    return theme;
  }

  columnDefs: ColDef[] = [
    { field: "make" },
    { field: "model" },
    { field: "price" },
  ];

  defaultColDef: ColDef = {
    editable: true,
    flex: 1,
    minWidth: 100,
    filter: true,
  };

  rowData: any[] = (() => {
    const rowData: any[] = [];
    for (let i = 0; i < 10; i++) {
      rowData.push({
        make: "Toyota",
        model: "Celica",
        price: 35000 + i * 1000,
      });
      rowData.push({ make: "Ford", model: "Mondeo", price: 32000 + i * 1000 });
      rowData.push({
        make: "Porsche",
        model: "Boxster",
        price: 72000 + i * 1000,
      });
    }
    return rowData;
  })();
}
```

[Live example: Configuring Theme Parts](https://www.ag-grid.com/archive/36.2.0/examples/theming-parts/configuring-theme-parts/angular/)

## Parts Reference

The following parts are available:

- `colorScheme` feature:
  - `colorSchemeVariable` - the default colour scheme for all our [built-in themes](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/themes/#built-in-themes). By default it appears light, but can be adjusted using [theme modes](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/theming-colors/#theme-modes).
  - `colorSchemeLight` - neutral light scheme
  - `colorSchemeLightCold` - light scheme with subtle cold tint
  - `colorSchemeLightWarm` - light scheme with subtle warm tint
  - `colorSchemeDark` - neutral dark scheme
  - `colorSchemeDarkBlue` - our preferred dark scheme used on this website
  - `colorSchemeDarkWarm` - dark scheme with subtle warm tint
- `iconSet` feature:
  - `iconSetQuartz` - our default icon set
    - `iconSetQuartz({strokeWidth: number})` you can call iconSetQuartz as a function to provide a custom stroke width in pixels (the default is 1.5)
    - `iconSetQuartzLight` and `iconSetQuartzBold` preset lighter and bolder versions of the Quartz icons with 1px and 2px stroke widths respectively.
  - `iconSetMaterial` - the Material Design icon set
  - `iconSetAlpine` - the icon set used by the Alpine theme
  - `iconSetBalham` - the icon set used by the Balham theme
- `buttonStyle` feature:
  - `buttonStyleBase` - unstyled buttons with many parameters to configure their appearance
  - `buttonStyleQuartz` - buttons styled as per the Quartz theme
  - `buttonStyleAlpine` - buttons styled as per the Alpine theme
  - `buttonStyleBalham` - buttons styled as per the Balham theme
- `columnDropStyle` feature - controls the styling of column drop zone in the [columns tool panel](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/tool-panel-columns/):
  - `columnDropStylePlain` - undecorated drop zone as used by Balham and Material themes
  - `columnDropStyleBordered` - drop zone with a dashed border around it as used by the Quartz and Alpine themes.
- `checkboxStyle` feature:
  - `checkboxStyleDefault` - checkbox style used by our themes. There is only one style provided which is configurable through parameters. It being a part allows you to replace it with your own checkbox styles if desired.
- `inputStyle` feature:
  - `inputStyleBase` - unstyled inputs with many parameters to configure their appearance
  - `inputStyleBordered` - inputs with a border around them
  - `inputStyleUnderlined` - inputs with a line underneath them as used in Material Design
- `tabStyle` feature:
  - `tabStyleBase` - unstyled tabs with many parameters to configure their appearance
  - `tabStyleQuartz` - tabs styled as per the Quartz theme
  - `tabStyleMaterial` - tabs styled as per the Material theme
  - `tabStyleAlpine` - tabs styled as per the Alpine theme
  - `tabStyleRolodex` - tabs designed to imitate paper cards, as used by the Balham theme
- `styleMaterial` feature (used by the Material theme):
  - `styleMaterial` - Adds the `primaryColor` parameter defined by [Material Design v2](https://m2.material.io/) and uses this colour instead of the `accentColor` for most coloured elements. `accentColor` is still used for checked checkboxes and to highlight active filters. This part also applies some adjustments to appearance of elements to match the Material Design specification, e.g. making all button text uppercase.

## Removing a Part

To remove a part from a theme, call `theme.withoutPart(featureName)`, which returns a new theme without the specified part:

```js
const myCustomTheme = themeQuartz.withoutPart('checkboxStyle');
```

After removing the built-in part, this example uses CSS in a separate style sheet to style the checkboxes:

#### Configuring Theme Parts

```ts
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./style.css";
import "./style.css";
import {
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  GridState,
  ModuleRegistry,
  RowSelectionOptions,
  Theme,
  enableDevValidations,
  themeQuartz,
} from "ag-grid-community";
import { AllEnterpriseModule } from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([AllEnterpriseModule]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [rowData]="rowData"
    [theme]="theme"
    [defaultColDef]="defaultColDef"
    [initialState]="initialState"
    [rowSelection]="rowSelection"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { field: "make" },
    { field: "model" },
    { field: "price" },
  ];
  rowData: IOlympicData[] | null = (() => {
    const rowData: any[] = [];
    for (let i = 0; i < 10; i++) {
      rowData.push({
        make: "Toyota",
        model: "Celica",
        price: 35000 + i * 1000,
      });
      rowData.push({ make: "Ford", model: "Mondeo", price: 32000 + i * 1000 });
      rowData.push({
        make: "Porsche",
        model: "Boxster",
        price: 72000 + i * 1000,
      });
    }
    return rowData;
  })();
  theme: Theme | "legacy" = myCustomTheme;
  defaultColDef: ColDef = {
    editable: true,
    flex: 1,
    minWidth: 100,
    filter: true,
  };
  initialState: GridState = {
    rowSelection: ["1", "2", "3"],
  };
  rowSelection: RowSelectionOptions | "single" | "multiple" = {
    mode: "multiRow",
    checkboxes: true,
  };
}

const myCustomTheme = themeQuartz.withoutPart("checkboxStyle");
```

[Live example: Configuring Theme Parts](https://www.ag-grid.com/archive/36.2.0/examples/theming-parts/removing-parts/angular/)

The above example uses `theme.withoutPart("checkboxStyle")` to disable the default checkbox styles and adds its own checkbox styles in the application style sheet. This is the simplest way of changing the appearance of the grid when you are working on a single application.

## Creating Your Own Parts

You can create your own theme parts to use in your application. This is useful for organisations with multiple apps that share common styles or a design system, see [Distributing Shared Themes & Parts](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/theming-distribution/#creating-your-own-parts).


---
product: "AG Grid"
title: "Theme Parts"
description: "Parts contain the CSS styles for a single feature like icons or text inputs."
framework: vue
version: "36.2.0"
related:
    - title: "Overview"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/theming/"
    - title: "Built-in Themes"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/themes/"
    - title: "Theme Parameters"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/theming-parameters/"
    - title: "Colors & Dark Mode"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/theming-colors/"
    - title: "Fonts"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/theming-fonts/"
    - title: "Borders"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/theming-borders/"
    - title: "Compactness & Row Height"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/theming-compactness/"
    - title: "Selections"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/theming-selections/"
    - title: "Headers"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/theming-headers/"
    - title: "Icons"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/custom-icons/"
    - title: "Master Detail"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/theming-master-detail/"
    - title: "Tool Panels"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/theming-tool-panels/"
    - title: "Inputs & Widgets"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/theming-widgets/"
    - title: "Menus & Popups"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/theming-popups/"
    - title: "Extending with CSS"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/theming-css/"
    - title: "Theme Builder"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/theming-theme-builder/"
    - title: "Distributing Shared Themes"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/theming-distribution/"
    - title: "Migration from v32"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/theming-migration/"
    - title: "Legacy Themes"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/theming-v32/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Theme Parts

Parts contain the CSS styles for a single feature like icons or text inputs.

Using parts you can, for example, select a text input style that matches you application, or disable our provided text input styles so that you can write your own.

## Configuring Theme Parts

To add a part to a theme, call the `theme.withPart(...)` method which returns a new theme using that part. A theme can only have one part for a given feature, so for example because all colour scheme parts have `feature: "colorScheme"`, adding a new colour scheme to a theme will remove any existing part.

```js
import { themeQuartz, colorSchemeDark, iconSetMaterial } from 'ag-grid-community';

// withPart() returns a new theme and calls can be chained
const myTheme = themeQuartz
    .withPart(iconSetMaterial)
    .withPart(colorSchemeDark);
```

This example demonstrates mixing and matching any built-in theme, icon set, and colour scheme:

#### Configuring Theme Parts

```ts
import { computed, createApp, defineComponent, ref } from "vue";

import type { ColDef } from "ag-grid-community";
import {
  ModuleRegistry,
  colorSchemeDark,
  colorSchemeDarkBlue,
  colorSchemeDarkWarm,
  colorSchemeLight,
  colorSchemeLightCold,
  colorSchemeLightWarm,
  colorSchemeVariable,
  enableDevValidations,
  iconSetAlpine,
  iconSetMaterial,
  iconSetQuartzBold,
  iconSetQuartzLight,
  iconSetQuartzRegular,
  themeAlpine,
  themeBalham,
  themeMaterial,
  themeQuartz,
} from "ag-grid-community";
import { AllEnterpriseModule } from "ag-grid-enterprise";
import { AgGridVue } from "ag-grid-vue3";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([AllEnterpriseModule]);

const baseThemes = [
  { id: "themeQuartz", theme: themeQuartz },
  { id: "themeBalham", theme: themeBalham },
  { id: "themeAlpine", theme: themeAlpine },
  { id: "themeMaterial", theme: themeMaterial },
];

const colorSchemes = [
  { id: "(unchanged)", part: null },
  { id: "colorSchemeLight", part: colorSchemeLight },
  { id: "colorSchemeLightCold", part: colorSchemeLightCold },
  { id: "colorSchemeLightWarm", part: colorSchemeLightWarm },
  { id: "colorSchemeDark", part: colorSchemeDark },
  { id: "colorSchemeDarkWarm", part: colorSchemeDarkWarm },
  { id: "colorSchemeDarkBlue", part: colorSchemeDarkBlue },
  { id: "colorSchemeVariable", part: colorSchemeVariable },
];

const iconSets = [
  { id: "(unchanged)", part: null },
  { id: "iconSetQuartzLight", part: iconSetQuartzLight },
  { id: "iconSetQuartzRegular", part: iconSetQuartzRegular },
  { id: "iconSetQuartzBold", part: iconSetQuartzBold },
  { id: "iconSetAlpine", part: iconSetAlpine },
  { id: "iconSetMaterial", part: iconSetMaterial },
];

const VueExample = defineComponent({
  template: `
        <div style="height: 100%; display: flex; flex-direction: column">
            <p style="flex: 0 1 0%">
                Theme:
                <select style="margin-right: 16px" v-model="baseTheme">
                    <option v-for="t in baseThemes" :value="t">{{ t.id }}</option>
                </select>
                Icons:
                <select style="margin-right: 16px" v-model="iconSet">
                    <option v-for="iconSet in iconSets" :value="iconSet">{{ iconSet.id }}</option>
                </select>
                Color scheme:
                <select style="margin-right: 16px" v-model="colorScheme">
                    <option v-for="colorScheme in colorSchemes" :value="colorScheme">{{ colorScheme.id }}</option>
                </select>
            </p>
            <div style="flex: 1 1 0%">
                <ag-grid-vue
                    style="height: 100%;"
                    :theme="theme"
                    :columnDefs="columnDefs"
                    :defaultColDef="defaultColDef"
                    :rowData="rowData"
                    :sideBar="true"
                ></ag-grid-vue>
            </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const baseTheme = ref(baseThemes[0]);
    const iconSet = ref(iconSets[0]);
    const colorScheme = ref(colorSchemes[0]);
    return {
      baseTheme,
      baseThemes,

      iconSet,
      iconSets,

      colorSchemes,
      colorScheme,

      theme: computed(() => {
        let theme = baseTheme.value.theme;
        if (colorScheme.value.part) {
          theme = theme.withPart(colorScheme.value.part);
        }
        if (iconSet.value.part) {
          theme = theme.withPart(iconSet.value.part);
        }
        return theme;
      }),

      columnDefs: <ColDef[]>[
        { field: "make" },
        { field: "model" },
        { field: "price" },
      ],
      defaultColDef: <ColDef>{
        editable: true,
        flex: 1,
        minWidth: 100,
        filter: true,
      },
      rowData: (() => {
        const rowData = [];
        for (let i = 0; i < 10; i++) {
          rowData.push({
            make: "Toyota",
            model: "Celica",
            price: 35000 + i * 1000,
          });
          rowData.push({
            make: "Ford",
            model: "Mondeo",
            price: 32000 + i * 1000,
          });
          rowData.push({
            make: "Porsche",
            model: "Boxster",
            price: 72000 + i * 1000,
          });
        }
        return rowData;
      })(),
    };
  },
});

createApp(VueExample).mount("#app");
```

[Live example: Configuring Theme Parts](https://www.ag-grid.com/archive/36.2.0/examples/theming-parts/configuring-theme-parts/vue3/)

## Parts Reference

The following parts are available:

- `colorScheme` feature:
  - `colorSchemeVariable` - the default colour scheme for all our [built-in themes](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/themes/#built-in-themes). By default it appears light, but can be adjusted using [theme modes](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/theming-colors/#theme-modes).
  - `colorSchemeLight` - neutral light scheme
  - `colorSchemeLightCold` - light scheme with subtle cold tint
  - `colorSchemeLightWarm` - light scheme with subtle warm tint
  - `colorSchemeDark` - neutral dark scheme
  - `colorSchemeDarkBlue` - our preferred dark scheme used on this website
  - `colorSchemeDarkWarm` - dark scheme with subtle warm tint
- `iconSet` feature:
  - `iconSetQuartz` - our default icon set
    - `iconSetQuartz({strokeWidth: number})` you can call iconSetQuartz as a function to provide a custom stroke width in pixels (the default is 1.5)
    - `iconSetQuartzLight` and `iconSetQuartzBold` preset lighter and bolder versions of the Quartz icons with 1px and 2px stroke widths respectively.
  - `iconSetMaterial` - the Material Design icon set
  - `iconSetAlpine` - the icon set used by the Alpine theme
  - `iconSetBalham` - the icon set used by the Balham theme
- `buttonStyle` feature:
  - `buttonStyleBase` - unstyled buttons with many parameters to configure their appearance
  - `buttonStyleQuartz` - buttons styled as per the Quartz theme
  - `buttonStyleAlpine` - buttons styled as per the Alpine theme
  - `buttonStyleBalham` - buttons styled as per the Balham theme
- `columnDropStyle` feature - controls the styling of column drop zone in the [columns tool panel](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/tool-panel-columns/):
  - `columnDropStylePlain` - undecorated drop zone as used by Balham and Material themes
  - `columnDropStyleBordered` - drop zone with a dashed border around it as used by the Quartz and Alpine themes.
- `checkboxStyle` feature:
  - `checkboxStyleDefault` - checkbox style used by our themes. There is only one style provided which is configurable through parameters. It being a part allows you to replace it with your own checkbox styles if desired.
- `inputStyle` feature:
  - `inputStyleBase` - unstyled inputs with many parameters to configure their appearance
  - `inputStyleBordered` - inputs with a border around them
  - `inputStyleUnderlined` - inputs with a line underneath them as used in Material Design
- `tabStyle` feature:
  - `tabStyleBase` - unstyled tabs with many parameters to configure their appearance
  - `tabStyleQuartz` - tabs styled as per the Quartz theme
  - `tabStyleMaterial` - tabs styled as per the Material theme
  - `tabStyleAlpine` - tabs styled as per the Alpine theme
  - `tabStyleRolodex` - tabs designed to imitate paper cards, as used by the Balham theme
- `styleMaterial` feature (used by the Material theme):
  - `styleMaterial` - Adds the `primaryColor` parameter defined by [Material Design v2](https://m2.material.io/) and uses this colour instead of the `accentColor` for most coloured elements. `accentColor` is still used for checked checkboxes and to highlight active filters. This part also applies some adjustments to appearance of elements to match the Material Design specification, e.g. making all button text uppercase.

## Removing a Part

To remove a part from a theme, call `theme.withoutPart(featureName)`, which returns a new theme without the specified part:

```js
const myCustomTheme = themeQuartz.withoutPart('checkboxStyle');
```

After removing the built-in part, this example uses CSS in a separate style sheet to style the checkboxes:

#### Configuring Theme Parts

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./style.css";
import {
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  GridState,
  ModuleRegistry,
  RowSelectionOptions,
  Theme,
  enableDevValidations,
  themeQuartz,
} from "ag-grid-community";
import { AllEnterpriseModule } from "ag-grid-enterprise";
import {} from "./style.css";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([AllEnterpriseModule]);

const myCustomTheme = themeQuartz.withoutPart("checkboxStyle");

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :rowData="rowData"
      :theme="theme"
      :defaultColDef="defaultColDef"
      :initialState="initialState"
      :rowSelection="rowSelection"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "make" },
      { field: "model" },
      { field: "price" },
    ]);
    const rowData = ref<IOlympicData[] | null>(
      (() => {
        const rowData: any[] = [];
        for (let i = 0; i < 10; i++) {
          rowData.push({
            make: "Toyota",
            model: "Celica",
            price: 35000 + i * 1000,
          });
          rowData.push({
            make: "Ford",
            model: "Mondeo",
            price: 32000 + i * 1000,
          });
          rowData.push({
            make: "Porsche",
            model: "Boxster",
            price: 72000 + i * 1000,
          });
        }
        return rowData;
      })(),
    );
    const theme = ref<Theme | "legacy">(myCustomTheme);
    const defaultColDef = ref<ColDef>({
      editable: true,
      flex: 1,
      minWidth: 100,
      filter: true,
    });
    const initialState = ref<GridState>({
      rowSelection: ["1", "2", "3"],
    });
    const rowSelection = ref<RowSelectionOptions | "single" | "multiple">({
      mode: "multiRow",
      checkboxes: true,
    });

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;
    };

    return {
      gridApi,
      columnDefs,
      rowData,
      theme,
      defaultColDef,
      initialState,
      rowSelection,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Configuring Theme Parts](https://www.ag-grid.com/archive/36.2.0/examples/theming-parts/removing-parts/vue3/)

The above example uses `theme.withoutPart("checkboxStyle")` to disable the default checkbox styles and adds its own checkbox styles in the application style sheet. This is the simplest way of changing the appearance of the grid when you are working on a single application.

## Creating Your Own Parts

You can create your own theme parts to use in your application. This is useful for organisations with multiple apps that share common styles or a design system, see [Distributing Shared Themes & Parts](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/theming-distribution/#creating-your-own-parts).
